using Tekla.Structures.Drawing;
using Tekla.Structures.Drawing.UI;
using System.Windows.Forms;
using System.Reflection;
using Tekla.Structures;
using TSM = Tekla.Structures.Model;
using System;

namespace Tekla.Technology.Akit.UserScript
{
partial class Form1: System.Windows.Forms.Form
    {
		private System.ComponentModel.IContainer components = null;
		private System.Windows.Forms.TextBox textBox1;
        private System.Windows.Forms.Button button1;

        /// <summary>
        /// Освободить все используемые ресурсы.
        /// </summary>
        /// <param name="disposing">истинно, если управляемый ресурс должен быть удален; иначе ложно.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Код, автоматически созданный конструктором форм Windows

        /// <summary>
        /// Обязательный метод для поддержки конструктора - не изменяйте
        /// содержимое данного метода при помощи редактора кода.
        /// </summary>
        private void InitializeComponent()
        {
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.button1 = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // textBox1
            // 
            this.textBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
            this.textBox1.Location = new System.Drawing.Point(12, 12);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(497, 22);
            this.textBox1.TabIndex = 0;
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(12, 43);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(497, 40);
            this.button1.TabIndex = 1;
            this.button1.Text = "Get file name";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi;
            this.ClientSize = new System.Drawing.Size(521, 95);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.textBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Name = "Form1";
            this.Text = "Получить имя файла чертежа";
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion

		public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DrawingHandler DH = new DrawingHandler();
            DrawingSelector DS = DH.GetDrawingSelector();
            DrawingEnumerator DE=DS.GetSelected();
            if (DE.MoveNext())
            {
                Drawing DR = DE.Current;
                Type drType = DR.GetType();
                PropertyInfo propertyInfo = drType.GetProperty("Identifier", BindingFlags.Instance | BindingFlags.NonPublic);
                object value = propertyInfo.GetValue(DR, null);
                Identifier drIdentifier = (Identifier)value;
                TSM.Beam Memb = new TSM.Beam { Identifier = drIdentifier };
                string FileName = "";
                Memb.GetReportProperty("PLOTFILE", ref FileName);
                textBox1.Text = FileName;
            }
        }
        
		}
    public class Script
    {
        public static void Run(Tekla.Technology.Akit.IScript akit)
        {
            Application.EnableVisualStyles();
            Application.Run(new Form1());
        }
    }
}
